VERSION 5.00
Begin VB.Form frmSHFormat 
   Caption         =   "SH Format Drive Sample"
   ClientHeight    =   2010
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5220
   LinkTopic       =   "Form1"
   ScaleHeight     =   2010
   ScaleWidth      =   5220
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   45
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   360
      Width           =   3390
   End
   Begin VB.CommandButton cmdSHFormat 
      Caption         =   "SHFormat"
      Default         =   -1  'True
      Height          =   375
      Left            =   3870
      TabIndex        =   1
      Top             =   45
      Width           =   1230
   End
   Begin VB.CommandButton cmdEnd 
      Cancel          =   -1  'True
      Caption         =   "End"
      Height          =   375
      Left            =   3870
      TabIndex        =   0
      Top             =   495
      Width           =   1230
   End
   Begin VB.Label Label3 
      Caption         =   "Formatting Message"
      Height          =   240
      Left            =   45
      TabIndex        =   7
      Top             =   1350
      Width           =   3390
   End
   Begin VB.Label Label2 
      Caption         =   "OS Setings"
      Height          =   240
      Left            =   90
      TabIndex        =   6
      Top             =   720
      Width           =   1545
   End
   Begin VB.Label Label1 
      Caption         =   "Select the &drive to Format"
      Height          =   195
      Left            =   45
      TabIndex        =   5
      Top             =   135
      Width           =   1905
   End
   Begin VB.Label lbMessage 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "lbMessage"
      Height          =   285
      Left            =   45
      TabIndex        =   4
      Top             =   1665
      Width           =   3390
   End
   Begin VB.Label lbOSType 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "lbOSType"
      Height          =   285
      Left            =   45
      TabIndex        =   3
      Top             =   990
      Width           =   3390
   End
End
Attribute VB_Name = "frmSHFormat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub Form_Load()

   Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2

  'Load the combo box with the user's drives & drive types
   LoadAvailableDrives

  'Preselect index 1 (typically a user's C drive if only 1 floppy is installed)
   Combo1.ListIndex = 1

  'Determine if the OS is NT or Win95 and assign the correct format variables
   If IsWinNT Then
      lbOSType = "(NT settings)"
      SHFD_FORMAT_FULL = 0     ' full format
      SHFD_FORMAT_QUICK = 1   ' quick format
   Else 'it's Win95
      lbOSType = "(Win95 settings)"
      SHFD_FORMAT_QUICK = 0         ' quick format
      SHFD_FORMAT_FULL = 1           ' full format
      SHFD_FORMAT_SYSONLY = 2   ' copies system files only
   End If
  
End Sub


Private Sub cmdSHFormat_Click()

  '------------------------------------------------------
  'Displays the Format Drive property sheet
  
   Dim r As Long
   Dim resp As Integer
   Dim drvToFormat As Integer
   Dim prompt As String

   drvToFormat = Combo1.ListIndex
   prompt = "Are you sure you want to run the Format dialog against " & Combo1.Text
   
   If drvToFormat > 0 Then
         resp = MsgBox(prompt, vbCritical Or vbYesNo, "Are you sure")
   Else: resp = vbYes
   End If
   
   If resp = vbYes Then
   
      lbMessage = "Checking drive for disk..."
      DoEvents
      
      r = SHFormatDrive(Me.hWnd, drvToFormat, SHFD_CAPACITY_DEFAULT, SHFD_FORMAT_QUICK)
      
      lbMessage = ""
      
   End If
   
End Sub


Private Sub cmdEnd_Click()

   Unload Me
   
End Sub


Private Sub Form_Unload(Cancel As Integer)
  
  Set frmSHFormat = Nothing
  End
  
End Sub


Private Function GetDriveDisplayString(currDrive As String) As String

  'from a passed drive string, determines the type of drive

   Select Case GetDriveType(currDrive)
      Case 0, 1: GetDriveDisplayString = " - Undetermined Drive Type -"
      
      Case DRIVE_REMOVABLE:
           Select Case Left(currDrive, 1)
              Case "A", "B": GetDriveDisplayString = "Floppy drive"
              Case Else:     GetDriveDisplayString = "Removable drive"
           End Select
      
      Case DRIVE_FIXED:     GetDriveDisplayString = "Fixed (Hard) drive"
      Case DRIVE_REMOTE:    GetDriveDisplayString = "Remote drive"
      Case DRIVE_CDROM:     GetDriveDisplayString = "CD ROM"
      Case DRIVE_RAMDISK:   GetDriveDisplayString = "Ram disk"
   End Select
  
End Function


Private Sub LoadAvailableDrives()

 'get the list of all available drives
 
  Dim r As Long
  Dim DriveSize As Long
  Dim lpBuffer  As String
  Dim currDrive  As String

 'return a string of all available drive
 'letters, each separated by a chr$(0)
 '(i.e. a:\*c:\*d:\**)
  
  lpBuffer$ = Space$(64)
  
  r = GetLogicalDriveStrings(Len(lpBuffer), lpBuffer)
  
  If r Then
    lpBuffer = Left$(lpBuffer, r)
  
    'Separate the drive strings and add them
    'to the combobox.
     Do Until lpBuffer = ""
     
      'strip off one drive item from the lpBuffer$
       currDrive = StripNulls(lpBuffer)
     
      'add the drive to the combo list
       Combo1.AddItem currDrive & "   " & GetDriveDisplayString(currDrive)
       
     Loop
  End If
  
End Sub


Function StripNulls(startStrg As String) As String

  'Take a string separated by Chr(0)'s, and split off 1 item, and
  'shorten the string so that the next item is ready for removal.

   Dim c As Integer
   Dim item As String
   
   c = 1
   
   Do
      
      If Mid(startStrg, c, 1) = Chr(0) Then
      
         item = Mid(startStrg, 1, c - 1)
         startStrg = Mid(startStrg, c + 1, Len(startStrg))
         StripNulls = item
         Exit Function
      
      End If
      
      c = c + 1
   
   Loop

End Function
