Attribute VB_Name = "modSHFormat"
Option Explicit

 '------------------------------------------------------
  'Determines if the current OS is WinNT.
  'Tested in the form load event only
   Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
         (lpVersionInformation As OSVERSIONINFO) As Long
                                     
   Type OSVERSIONINFO
      dwOSVersionInfoSize As Long
      dwMajorVersion As Long
      dwMinorVersion As Long
      dwBuildNumber As Long
      dwPlatformId As Long
      szCSDVersion As String * 128      ' Maintenance string for PSS usage
   End Type
   
   Const VER_PLATFORM_WIN32s = 0
   Const VER_PLATFORM_WIN32_WINDOWS = 1
   Const VER_PLATFORM_WIN32_NT = 2

   
  '------------------------------------------------------
  'APIs declarations for the format function
   
   Public Declare Function SHFormatDrive Lib "shell32" _
         (ByVal hwndOwner As Long, _
          ByVal iDrive As Long, _
          ByVal iCapacity As Long, _
          ByVal iFormatType As Long) As Long
   
   Public Const SHFD_CAPACITY_DEFAULT = 0     ' default drive capacity
   Public Const SHFD_CAPACITY_360 = 3            ' 360KB, applies to 5.25" drives only
   Public Const SHFD_CAPACITY_720 = 5            ' 720KB, applies to 3.5" drives only
 
  'Normally, these below would be declared as constants,
  'if the values between Win95 and NT were the same (see
  'the commented-out const values below).
   Public SHFD_FORMAT_QUICK As Long
   Public SHFD_FORMAT_FULL As Long
   Public SHFD_FORMAT_SYSONLY As Long
  '
  'However, because VB lacks a conditional #If variable
  'to distinguish between Win95 and NT, they are DIMmed
  'here and set in the Form_Load routine after GetVersionEx
  'has been called.
  '
  'Win95
  'Public Const SHFD_FORMAT_QUICK = 0         ' quick format
  'Public Const SHFD_FORMAT_FULL = 1           ' full format
  'Public Const SHFD_FORMAT_SYSONLY = 2   ' copies system files only
   
  'WinNT
  'Public Const SHFD_FORMAT_FULL = 0     ' full format
  'Public Const SHFD_FORMAT_QUICK = 1   ' quick format
      
  '------------------------------------------------------
  'support APIs to populate the combo box with the available drives
  
   Public Declare Function GetLogicalDriveStrings Lib _
        "kernel32" Alias "GetLogicalDriveStringsA" _
        (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
   
   Public Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" _
        (ByVal nDrive As String) As Long
   
   Public Const DRIVE_REMOVABLE = 2
   Public Const DRIVE_FIXED = 3
   Public Const DRIVE_REMOTE = 4
   Public Const DRIVE_CDROM = 5
   Public Const DRIVE_RAMDISK = 6
   

Public Function IsWinNT() As Boolean

  'Returns True if the current operating system is WinNT
 
   Dim osvi As OSVERSIONINFO
   osvi.dwOSVersionInfoSize = Len(osvi)
   GetVersionEx osvi
   IsWinNT = (osvi.dwPlatformId = VER_PLATFORM_WIN32_NT)
   
End Function

